#pragma once

struct rcConfig;
struct dtTileCacheParams;
struct dtNavMeshParams;
struct BuilderParams;
struct TileCacheData;
class dtNavMesh;
class MapInstance;
class NavMeshBuilder : public a8::Singleton<NavMeshBuilder>
{
private:
    NavMeshBuilder() {};
    friend class a8::Singleton<NavMeshBuilder>;

public:
    void Init();
    void UnInit();

    void Build(MapInstance* map_instance);

 private:
    void InitBuilderParams(BuilderParams& builder_params);
    void InitTileCacheParams(BuilderParams& builder_params, dtTileCacheParams& tcparams);
    void InitNavMeshParams(BuilderParams& builder_params, dtNavMeshParams& params);
    void BuildTiles(BuilderParams& builder_params);
    int RasterizeTileLayers(BuilderParams& builder_params,
                            const int tx,
                            const int ty,
                            const rcConfig& cfg,
                            TileCacheData* tiles,
                            const int maxTiles);
    bool CreateTileCache(BuilderParams& builder_params);
    bool CreateNavMesh(BuilderParams& builder_params);
    void BuildMapObstalce(BuilderParams& builder_params);
    void Save(BuilderParams& builder_params);
};
